<template>
  <header class="MobileSideBar__Head">
    <p-Button
      class="MobileSideBar__Button"
      icon="mdi mdi-menu"
      @click="visible = true"
    />
    <h1 class="MobileSideBar__HeadTitle">{{ title }}</h1>
  </header>
  <p-Sidebar v-model:visible="visible" class="MobileSideBar">
    <router-link :to="'/'" class="MobileSideBar__Logo" />
    <div class="MobileSideBar__User">
      <UserAvatar :user-id="settings.user.id" />
      {{ settings.user.name || settings.user.email }}
    </div>
    <Nav
      class="MobileSideBar__Nav"
      :items="mobileMenuItems"
      :actions="[LogOut]"
      @click="visible = false"
    />
  </p-Sidebar>
</template>

<script lang="ts" setup>
import { ref } from 'vue'
import Nav from './Nav.vue'
import { useI18n } from 'vue-i18n'
import { LogOut } from '@/components/bars/ActionItems'
import { mainMenuItems, Settings } from '@/components/bars/LinkItems'
import { getTitle } from '@/components/bars/useTitle'
import { injectStrict } from '@/injectStrict'
import { SettingsKey } from '@/provided'
import { UserAvatar } from '@/components/avatar'

const settings = injectStrict(SettingsKey)
const mobileMenuItems = [...mainMenuItems.value, Settings]

const visible = ref<boolean>(false)

const t = useI18n().t
const title = getTitle()
</script>

<style lang="scss">
@use 'src/style/variables' as v;
@use 'src/style/mixins' as m;

.MobileSideBar__Head {
  @include m.mobile {
    display: grid;
    grid-template-areas: 'button title seconday';
    grid-template-columns: min-content auto min-content;
    grid-gap: v.$spacing;
  }

  display: none;
  grid-area: topBar;
  align-items: center;
  padding: v.$spacing-2;
  background-color: var(--primary-color);

  &Button {
    grid-area: button;
    color: var(--primary-color-text);
  }

  &Title {
    grid-area: title;
    margin: 0;
    padding: 0;
    color: var(--primary-color-text);
    font-weight: 400;
    font-size: 1.5rem;
  }
}

.MobileSideBar {
  &.p-sidebar {
    @include m.mobile {
      display: inherit;
    }

    display: none;
  }

  .p-sidebar-header {
    position: absolute;
    right: 0;
    z-index: 1000;
  }

  .p-sidebar-content {
    position: relative;
    display: flex;
    flex-direction: column;
    justify-content: stretch;
    height: 100vh;
    border: none;
    border-right: 1px solid var(--grey-50);
  }

  &__Logo {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    width: 100%;
    padding: v.$spacing;
    background: var(--logoUrl);
    background-position: center;
    background-size: auto;
    background-repeat: no-repeat;
  }

  &__User {
    display: flex;
    flex-direction: row;
    gap: v.$spacing-2;
    align-items: center;
    margin-bottom: v.$spacing;
    padding: v.$spacing 0;
    border-bottom: solid 1px var(--gray-50);
  }
}

.p-sidebar-mask.p-component-overlay {
  @include m.mobile {
    display: inherit;
  }

  display: none;
}
</style>
